/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2008 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: vcedge.c
***                                                            
*** Comments: 
*** 
***	   Test of OpenCV Canny edge detector
***
*** Revision History:
***    Date          Version    Author  Changes
***    Oct 01, 2008  3.03       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/
#include <cv.h>

#include <register.h>
#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include "\ti\opencv\VC\include\vc.h"
#include <licence.h>


int edge_thresh = 1;

IplImage *cedge = 0, *gray = 0, *cinp = 0;


int main( int argc, char** argv )
{
  int i;


    INIT_LICENCE();
	init_VC_openCV_interface();

    printf("OpenCV edge detection - hit any key\n"); rs232rcv();

    /* take a picture  															*/

    tpict();


	/* create input image header												*/

    cinp = cvCreateImageHeader(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 1);
	cvSetImageROI(cinp, cvRect(0, 0, ScrGetPitch, ScrGetRows));					/* set ROI to actual image	*/
	cvSetImageStart(cinp, (char *)ScrGetPhysPage);


    /* Create the output image													*/
    cedge = cvCreateImage(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 1);

    /* Convert to grayscale														*/
    gray = cvCreateImage(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 1);


//	for(i=0; i<1000; i++)
	  {
      tpict();

      cvSmooth( cinp, cedge, CV_BLUR, 7, 7, 0, 0 );

      cvCopy( cedge, cinp, NULL );

      cvNot(cedge, gray );
      cvCopy( gray, cinp, NULL );

	  edge_thresh = 6;
      // Run the edge detector on grayscale
      cvCanny(gray, cedge, (float)edge_thresh, (float)edge_thresh*3, 3);

      cvCopy( cedge, cinp, NULL );

  	  }


    cvReleaseImage(&gray);
    cvReleaseImage(&cedge);

    cvReleaseImageHeader(&cinp);

    return 0;
}



/* EOF */
