/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2008 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: vcharris.c
***                                                            
*** Comments: 
*** 
***	   Test of OpenCV Harris Corner Detector
***
*** Revision History:
***    Date          Version    Author  Changes
***    Oct 01, 2008  3.03       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/
#include "cv.h"

#include <register.h>
#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include "\ti\opencv\VC\include\vc.h"
#include <licence.h>


int block_size = 3;

/* globals for histogram	*/
float range_0[]={0,256};
float* ranges[] = { range_0 };
CvHistogram *hist;
int hist_size = 64;

IplImage *img = 0, *cedge = 0, *gray = 0, *corner = 0, *cinp = 0;


int main( int argc, char** argv )
{
  int i;
  float min_value = 0.0;
  float max_value = 0.0;


    INIT_LICENCE();
	init_VC_openCV_interface();

    printf("OpenCV corner detection - hit any key\n"); rs232rcv();

/* take a picture  */

    tpict();


/* create input image header	*/

    cinp = cvCreateImageHeader(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 1);
	cvSetImageROI( cinp, cvRect(0, 0, ScrGetPitch, ScrGetRows));					/* set ROI to actual image	*/
	cvSetImageStart(cinp, (char *)ScrGetPhysPage);

    // Create the output image
    corner = cvCreateImage(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_32F, 1);

    // Convert to grayscale
    gray = cvCreateImage(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 1);


//    hist = cvCreateHist(1, &hist_size, CV_HIST_ARRAY, ranges, 1);
    hist = cvCreateHist(1, &hist_size, CV_HIST_SPARSE, ranges, 1);
 

//	for(i=0; i<1000; i++)
	  {
      tpict();

      cvCornerMinEigenVal( cinp, corner, block_size, 3);

      cvCalcHist( &corner, hist, 0, NULL );
      cvGetMinMaxHistValue( hist, &min_value, &max_value, 0, 0 );
	  printf("min: %e max: %e\n", min_value, max_value);


//      cvCopy( corner, cinp, NULL );
      cvConvertScale( corner, cinp, 1, 0 );



  	  }


//    cvReleaseImage(&img);
    cvReleaseHist(&hist);

    cvReleaseImage(&gray);
    cvReleaseImage(&corner);

    cvReleaseImageHeader(&cinp);

    return 0;
}



/* EOF */
