/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2008 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: vcimgld.c
***                                                            
*** Comments: 
*** 
***	   Test of OpenCV image load / save functions
***    currently does not work due to some bugs in highgui library
***
*** Revision History:
***    Date          Version    Author  Changes
***    Oct 02, 2008  3.03       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR
#include <cv.h>
#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <licence.h>

CVAPI(IplImage*) cvLoadImage( const char* filename, int iscolor CV_DEFAULT(CV_LOAD_IMAGE_COLOR));


int main( int argc, char** argv )
{
    int old_color_mode, old_disp_start;
    char* filename = (char*)"md:/fruits.tif";

    IplImage *src, *frame;      
    image rgb, bayer;


    INIT_LICENCE();
	init_VC_openCV_interface();


    printf("OpenCV image load/save operations - hit any key\n"); rs232rcv();

    /* on color cameras create RGB output image							*/

    if(getvar(COLOR_MODE) == DISP_NO_COLOR)
      {
      printf("B/W camera\n");
	  return -1;
      }
    else
      {
      ImageAssignC(&bayer, (U8 *)getvar(CAPT_START), IMAGE_BAYER, ScrGetColumns, ScrGetRows, ScrGetPitch, 0, 0);
      ImageAllocate(&rgb, IMAGE_RGB, getvar(VPITCH), getvar(DVWIDTH));		/* allocate RGB color image		*/
      rgb.dx = getvar(DHWIDTH);											    /* set dx to actual width		*/

      old_color_mode = getvar(COLOR_MODE);									/* save settings				*/
      old_disp_start = getvar(DISP_START);

      setvar(COLOR_MODE, DISP_RGB);
      setvar(DISP_START,(int)rgb.st);

      ColorBar(&rgb, 255, 255);
      }

    /* create color image 													*/

    frame = cvCreateImage(cvSize(ScrGetPitch, ScrGetRows), IPL_DEPTH_8U, 3);

    /* load image       													*/

	printf("load image: %s - hit key\n", filename); rs232rcv();

    if( (src = cvLoadImage(filename, 1)) == 0 ) 							/* load image					*/
	   {
	   printf("unable to open file\n");
	   return -1;
	   }

    /* copy to screen														*/

    printf("copy to VC: %d\n", copyVC(src, &rgb));

    printf("take picture\n"); rs232rcv();

	tpict();

    printf("convert to RGB\n"); rs232rcv();

    BayerToRGB(&bayer, &rgb);

    copyCV(&rgb, frame);

    printf("save image\n"); rs232rcv();

    cvSaveImage( "md:/image.tif", frame );

#if 0
    copyCV(&rgb, src);
 
    cvCvtColor( src, hsv, CV_BGR2HSV );
    cvCvtPixToPlane( hsv, h_plane, s_plane, v_plane, 0 );

	printf("now histogram\n"); rs232rcv();

    hist = cvCreateHist( 2, hist_size, CV_HIST_ARRAY, ranges, 1 );
    cvCalcHist( planes, hist, 0, 0 );
    cvGetMinMaxHistValue( hist, 0, &max_value, 0, 0 );
    cvZero( hist_img );

        for( h = 0; h < h_bins; h++ )
        {
            for( s = 0; s < s_bins; s++ )
            {
                float bin_val = cvQueryHistValue_2D( hist, h, s );
                int intensity = cvRound(bin_val*255/max_value);
                cvRectangle( hist_img, cvPoint( h*scale, s*scale ),
                             cvPoint( (h+1)*scale - 1, (s+1)*scale - 1),
                             CV_RGB(intensity,intensity,intensity), /* draw a grayscale histogram.
                                                                       if you have idea how to do it
                                                                       nicer let us know */
                             CV_FILLED, 8, 0 );
            }
        }


   rs232rcv();
#endif

   cvReleaseImage(&src);
   cvReleaseImage(&frame);

   if(getvar(COLOR_MODE) != DISP_NO_COLOR)
	  {
	  setvar(COLOR_MODE, old_color_mode);		/* restore settings		*/
      setvar(DISP_START, old_disp_start);
	  ImageFree(&rgb);
	  }

}




/* EOF */
